searchNodes=[{"doc":"Provide easy access to information inside the templates rendered by mix xtra","ref":"Extractly.html","title":"Extractly","type":"module"},{"doc":"Emits a comment including a message not to edit the created file, as it will be recreated from this template. It is a convenience to include this into your templates as follows &lt; % = xtra . do_not_edit_warning % &gt; or I18n'ed &lt; % = xtra . do_not_edit_warning , lang : :fr % &gt; If you are not generating html or markdown the comment can be parametrized &lt; % = xtra . do_not_edit_warning , comment_start : &quot;-- &quot; , comment_end : &quot;&quot; % &gt; If you want to include the name of the source template use template: template option, so a call may be as complex as: &lt; % = xtra . do_not_edit_warning , comment_start : &quot;-- &quot; , comment_end : &quot;&quot; , template : template , lang : :it % &gt;","ref":"Extractly.html#do_not_edit_warning/1","title":"Extractly.do_not_edit_warning/1","type":"function"},{"doc":"Returns docstring of a function Ex: iex(1)&gt; { :ok , lines } = Extractly . functiondoc ( &quot;Extractly.moduledoc/2&quot; ) |&gt; hd ( ) ...(1)&gt; lines |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot; Returns docstring of a module&quot; , &quot;&quot; , &quot; E.g. verbatim&quot; ] We can also pass a list of functions to get their docs concatenated iex(2)&gt; [ { :ok , moduledoc } , { :error , message } ] = Extractly . functiondoc ( [ &quot;Extractly.moduledoc/2&quot; , &quot;Extactly.functiondoc/2&quot; ] ) ...(2)&gt; moduledoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 4 ) [ &quot; Returns docstring of a module&quot; , &quot; E.g. verbatim&quot; , &quot;&quot; , &quot; Extractly.moduledoc( \\&quot; Extractly \\&quot; )&quot; ] ...(2)&gt; message &quot;Function doc for function Extactly.functiondoc/2 not found&quot; If all the functions are in the same module the following form can be used iex(3)&gt; [ { :ok , out } , _ ] = Extractly . functiondoc ( [ &quot;moduledoc/2&quot; , &quot;functiondoc/2&quot; ] , module : &quot;Extractly&quot; ) ...(3)&gt; String . split ( out , &quot; \\n &quot; ) |&gt; hd ( ) &quot; Returns docstring of a module&quot; However it is convenient to add a markdown headline before each functiondoc, especially in these cases, it can be done by indicating the headline: level option iex(4)&gt; [ { :ok , moduledoc } , { :ok , functiondoc } ] = Extractly . functiondoc ( [ &quot;moduledoc/2&quot; , &quot;functiondoc/2&quot; ] , module : &quot;Extractly&quot; , headline : 2 ) ...(4)&gt; moduledoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.moduledoc/2&quot; , &quot;&quot; , &quot; Returns docstring of a module&quot; ] ...(4)&gt; functiondoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.functiondoc/2&quot; , &quot;&quot; , &quot; Returns docstring of a function&quot; ] Often times we are interested by all public functiondocs... iex(5)&gt; [ { :ok , out } | _ ] = Extractly . functiondoc ( :all , module : &quot;Extractly&quot; , headline : 2 ) ...(5)&gt; String . split ( out , &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly.do_not_edit_warning/1&quot; , &quot;&quot; , &quot; Emits a comment including a message not to edit the created file, as it will be recreated from this template.&quot; ] We can specify a language to wrap indented code blocks into ```elixir\\n...\\n``` Here is an example iex(6)&gt; [ ok : doc ] = Extractly . functiondoc ( &quot;Extractly.functiondoc/2&quot; , wrap_code_blocks : &quot;elixir&quot; ) ...(6)&gt; doc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 10 ) [ &quot; Returns docstring of a function&quot; , &quot; Ex:&quot; , &quot;&quot; , &quot;```elixir&quot; , &quot; iex(1)&gt; {:ok, lines} = Extractly.functiondoc( \\&quot; Extractly.moduledoc/2 \\&quot; ) |&gt; hd()&quot; , &quot; ...(1)&gt; lines |&gt; String.split( \\&quot; \\\\ n \\&quot; ) |&gt; Enum.take(3)&quot; , &quot; [ \\&quot; Returns docstring of a module \\&quot; , \\&quot; \\&quot; , \\&quot; E.g. verbatim \\&quot; ]&quot; , &quot;```&quot; , &quot;&quot; , &quot; We can also pass a list of functions to get their docs concatenated&quot; ]","ref":"Extractly.html#functiondoc/2","title":"Extractly.functiondoc/2","type":"function"},{"doc":"Returns docstring of a macro","ref":"Extractly.html#macrodoc/2","title":"Extractly.macrodoc/2","type":"function"},{"doc":"Returns docstring of a module E.g. verbatim iex(7)&gt; { :ok , doc } = Extractly . moduledoc ( &quot;Extractly&quot; ) ...(7)&gt; doc &quot; Provide easy access to information inside the templates rendered by `mix xtra` \\n &quot; We can use the same options as with functiondoc iex(8)&gt; { :ok , doc } = Extractly . moduledoc ( &quot;Extractly&quot; , headline : 2 ) ...(8)&gt; doc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 3 ) [ &quot;## Extractly&quot; , &quot;&quot; , &quot; Provide easy access to information inside the templates rendered by `mix xtra`&quot; ] If we also want to use functiondoc :all, module: &quot;Extractly&quot; after the call of moduledoc we can include :all in the call of moduledoc , which will include function and macro docstrings as well iex(9)&gt; [ { :ok , moduledoc } | _ ] = ...(9)&gt; moduledoc ( &quot;Extractly&quot; , headline : 3 , include : :all ) ...(9)&gt; moduledoc &quot;### Extractly \\n \\n Provide easy access to information inside the templates rendered by `mix xtra` \\n &quot; iex(10)&gt; [ _ , { :ok , first_functiondoc } | _ ] = ...(10)&gt; moduledoc ( &quot;Extractly&quot; , headline : 3 , include : :all ) ...(10)&gt; first_functiondoc |&gt; String . split ( &quot; \\n &quot; ) |&gt; Enum . take ( 5 ) [ &quot;### Extractly.do_not_edit_warning/1&quot; , &quot;&quot; , &quot; Emits a comment including a message not to edit the created file, as it will be recreated from this template.&quot; , &quot;&quot; , &quot; It is a convenience to include this into your templates as follows&quot; ]","ref":"Extractly.html#moduledoc/2","title":"Extractly.moduledoc/2","type":"function"},{"doc":"Returns the output of a mix task Ex: iex(14)&gt; Extractly . task ( &quot;cmd&quot; , ~W[echo 42] ) &quot;42 \\n &quot; iex(15)&gt; try do ...(15)&gt; Extractly . task ( &quot;xxx&quot; ) ...(15)&gt; rescue ...(15)&gt; e in RuntimeError -&gt; e . message |&gt; String . split ( &quot; \\n &quot; ) |&gt; hd ( ) ...(15)&gt; end &quot;The following output was produced wih error code 1&quot;","ref":"Extractly.html#task/2","title":"Extractly.task/2","type":"function"},{"doc":"Extract Table Of Contents from a markdown document The files used for the following doctest can be found here iex(11)&gt; lines = [ ...(11)&gt; &quot;## Usage&quot; , ...(11)&gt; &quot;### API&quot; , ...(11)&gt; &quot;#### EarmarkParser.as_ast/2&quot; , ...(11)&gt; &quot;### Support&quot; , ...(11)&gt; ] ...(11)&gt; toc ( lines , gh_links : true ) { :ok , [ &quot;- [Usage](#usage)&quot; , &quot; - [API](#api)&quot; , &quot; - [EarmarkParser.as_ast/2](#earmarkparseras_ast2)&quot; , &quot; - [Support](#support)&quot; , ] } But if you do not want links iex(12)&gt; lines = [ ...(12)&gt; &quot;## Usage&quot; , ...(12)&gt; &quot;### API&quot; , ...(12)&gt; &quot;#### EarmarkParser.as_ast/2&quot; , ...(12)&gt; &quot;### Support&quot; , ...(12)&gt; ] ...(12)&gt; toc ( lines ) { :ok , [ &quot;- Usage&quot; , &quot; - API&quot; , &quot; - EarmarkParser.as_ast/2&quot; , &quot; - Support&quot; , ] } In case of bad options an error tuple is returned (no utf8 encoded input should ever result in an error_tuple iex(13)&gt; lines = [ ] # options are checked even if input is empty ...(13)&gt; toc ( lines , no_such_option : &quot;x&quot; ) { :error , &quot;Unsupported option no_such_option&quot; } A more detailed description can be found in Extractly.Toc 's docstrings","ref":"Extractly.html#toc/2","title":"Extractly.toc/2","type":"function"},{"doc":"A convenience method to access this libraries version","ref":"Extractly.html#version/0","title":"Extractly.version/0","type":"function"},{"doc":"Exposes the mix task as an escript for usage on non mix projects","ref":"Extractly.Cli.html","title":"Extractly.Cli","type":"module"},{"doc":"entry to the CLI, proxies to the mix task mix xtra","ref":"Extractly.Cli.html#main/1","title":"Extractly.Cli.main/1","type":"function"},{"doc":"Processes the extracted docstring according to %extractly%&lt;directive&gt;% directives","ref":"Extractly.Directives.html","title":"Extractly.Directives","type":"module"},{"doc":"","ref":"Extractly.Directives.html#process/2","title":"Extractly.Directives.process/2","type":"function"},{"doc":"Implements the storage of DO NOT EDIT warning messages for languages and various variations.","ref":"Extractly.DoNotEdit.html","title":"Extractly.DoNotEdit","type":"module"},{"doc":"Resolves to the correctly configured and internationalized message","ref":"Extractly.DoNotEdit.html#warning/1","title":"Extractly.DoNotEdit.warning/1","type":"function"},{"doc":"","ref":"Extractly.Frontend.html","title":"Extractly.Frontend","type":"module"},{"doc":"Implementation of the BL around the message collecting agent Extractly.Messages.Agent","ref":"Extractly.Messages.html","title":"Extractly.Messages","type":"module"},{"doc":"","ref":"Extractly.Messages.html#add_debug/1","title":"Extractly.Messages.add_debug/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_error/1","title":"Extractly.Messages.add_error/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_info/1","title":"Extractly.Messages.add_info/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#add_warning/1","title":"Extractly.Messages.add_warning/1","type":"function"},{"doc":"","ref":"Extractly.Messages.html#messages/1","title":"Extractly.Messages.messages/1","type":"function"},{"doc":"An agent that collects messages from all templates","ref":"Extractly.Messages.Agent.html","title":"Extractly.Messages.Agent","type":"module"},{"doc":"","ref":"Extractly.Messages.Agent.html#add_message/1","title":"Extractly.Messages.Agent.add_message/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Extractly.Messages.Agent.html#child_spec/1","title":"Extractly.Messages.Agent.child_spec/1","type":"function"},{"doc":"","ref":"Extractly.Messages.Agent.html#messages/0","title":"Extractly.Messages.Agent.messages/0","type":"function"},{"doc":"","ref":"Extractly.Messages.Agent.html#start_link/0","title":"Extractly.Messages.Agent.start_link/0","type":"function"},{"doc":"Extract Table Of Contents from a list of lines representing a Markdown document","ref":"Extractly.Toc.html","title":"Extractly.Toc","type":"module"},{"doc":"","ref":"Extractly.Toc.html#placeholder_pfx/0","title":"Extractly.Toc.placeholder_pfx/0","type":"function"},{"doc":"Depending on the options the Table Of Contents extracted from the lines can be rendered in different formats, the default being Markdown Markdown iex(1)&gt; render ( [ &quot;# Hello&quot; , &quot;## World&quot; ] ) [ &quot;- Hello&quot; , &quot; - World&quot; ] Numbered lists can be created too iex(2)&gt; render ( [ &quot;# Hello&quot; , &quot;## World&quot; ] , type : :ol ) [ &quot;1. Hello&quot; , &quot; 1. World&quot; ] Oftentimes the level of headlines is adapted for output, e.g. ### for the top and ##### for the second level. render accounts for that iex(3)&gt; render ( [ &quot;### Alpha&quot; , &quot;ignored&quot; , &quot;##### Alpha.1&quot; , &quot;&quot; , &quot;### Beta&quot; ] ) [ &quot;- Alpha&quot; , &quot; - Alpha.1&quot; , &quot;- Beta&quot; ] Remove Gaps Sometimes there will be gaps in the levels of headlines and these holes might not reflect semantic but rather stylistic concerns, if this is the case the option remove_gaps can be set to true iex(4)&gt; render ( [ &quot;# First&quot; , &quot;### Third (but will go to second level)&quot; , &quot;## Second&quot; ] , remove_gaps : true ) [ &quot;- First&quot; , &quot; - Third (but will go to second level)&quot; , &quot; - Second&quot; ] Github README Links This is all nice, however a TOC is most useful if links are provided. render can render Github like links to within the page, here is a real world example from a Github README.md file iex(5)&gt; lines = [ ...(5)&gt; &quot;## Usage&quot; , ...(5)&gt; &quot;### API&quot; , ...(5)&gt; &quot;#### EarmarkParser.as_ast/2&quot; , ...(5)&gt; &quot;### Support&quot; , ...(5)&gt; ] ...(5)&gt; render ( lines , gh_links : true ) [ &quot;- [Usage](#usage)&quot; , &quot; - [API](#api)&quot; , &quot; - [EarmarkParser.as_ast/2](#earmarkparseras_ast2)&quot; , &quot; - [Support](#support)&quot; , ] HTML Sometimes it might be appropriate to generate HTML directly iex(6)&gt; render ( [ &quot;## One&quot; , &quot;### Two&quot; ] , format : :html ) [ &quot;&lt;ul&gt;&quot; , &quot;&lt;li&gt;One&lt;ul&gt;&quot; , &quot;&lt;li&gt;Two&lt;/li&gt;&quot; , &quot;&lt;/ul&gt;&lt;/li&gt;&quot; , &quot;&lt;/ul&gt;&quot; ] Exlcuding levels and changing list styles Let us examine these two options with HTML output, they work too for Markdown of course, but are meaningless with the more raw output formats So we do not want to include levels greater than, say 3, and we also want to ignore top level headlines, probably because only one top level part has sublevels iex(7)&gt; document = [ ...(7)&gt; &quot;# Ignore&quot; , ...(7)&gt; &quot;# Too, but not what&#39;s below&quot; , ...(7)&gt; &quot;## Synopsis&quot; , ...(7)&gt; &quot;## Description&quot; , ...(7)&gt; &quot;### API&quot; , ...(7)&gt; &quot;#### too detailed&quot; , ...(7)&gt; &quot;### Tips &amp; Tricks&quot; , ...(7)&gt; &quot;# Ignored again&quot; ...(7)&gt; ] ...(7)&gt; render ( document , format : :html , min_level : 2 , max_level : 3 , start : 5 , type : :ol ) [ ~S{&lt;ol start=&quot;5&quot;&gt;} , ~S{&lt;li&gt;Synopsis&lt;/li&gt;} , ~S{&lt;li&gt;Description&lt;ol&gt;} , ~S{&lt;li&gt;API&lt;/li&gt;} , ~S{&lt;li&gt;Tips &amp;amp; Tricks&lt;/li&gt;} , ~S{&lt;/ol&gt;&lt;/li&gt;} , ~S{&lt;/ol&gt;} , ] PushList Either a linear PushList iex(8)&gt; render ( [ &quot;# I&quot; , &quot;## I.1&quot; , &quot;## I.2&quot; , &quot;### I.2.(i)&quot; , &quot;# II&quot; , &quot;### II.1.(ii)&quot; ] , format : :push_list ) [ &quot;I&quot; , :open , &quot;I.1&quot; , &quot;I.2&quot; , :open , &quot;I.2.(i)&quot; , :close , :close , &quot;II&quot; , :open , :open , &quot;II.1.(ii)&quot; , :close , :close ] AST tree iex(9)&gt; render ( [ &quot;# I&quot; , &quot;## I.1&quot; , &quot;## I.2&quot; , &quot;### I.2.(i)&quot; , &quot;# II&quot; , &quot;### II.1.(ii)&quot; ] , format : :ast ) [ &quot;I&quot; , [ &quot;I.1&quot; , &quot;I.2&quot; , [ &quot;I.2.(i)&quot; ] ] , &quot;II&quot; , [ [ &quot;II.1.(ii)&quot; ] ] ] Unsupported Formats iex(9)&gt; render ( [ &quot;# Does not really matter&quot; ] , format : :unknown ) { :error , &quot;Unsupported format: unknown in render&quot; }","ref":"Extractly.Toc.html#render/2","title":"Extractly.Toc.render/2","type":"function"},{"doc":"","ref":"Extractly.Toc.Renderer.AstRenderer.html","title":"Extractly.Toc.Renderer.AstRenderer","type":"module"},{"doc":"A structural nested array (extracted from the PushList ) iex(2)&gt; render_ast ( [ { 1 , &quot;I&quot; } , { 3 , &quot;I - (i)&quot; } , { 1 , &quot;II&quot; } , { 2 , &quot;II 1&quot; } ] ) [ &quot;I&quot; , [ [ &quot;I - (i)&quot; ] ] , &quot;II&quot; , [ &quot;II 1&quot; ] ]","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_ast/2","title":"Extractly.Toc.Renderer.AstRenderer.render_ast/2","type":"function"},{"doc":"Transform a normalized tuple list (that is a list of tuples of the form {n, text}) in which there exists an entry of the form {m, text} for all m betwenn min(n) and max(n) Two formats are supported The simple PushList where the tuple list is transformed into a linear structural representation of the different levels by representing opening and closing brackets by the symbols :open and :close iex(1)&gt; render_push_list ( [ { 1 , &quot;I&quot; } , { 3 , &quot;I - (i)&quot; } , { 1 , &quot;II&quot; } , { 2 , &quot;II 1&quot; } ] ) [ &quot;I&quot; , :open , :open , &quot;I - (i)&quot; , :close , :close , &quot;II&quot; , :open , &quot;II 1&quot; , :close ] This format is ideal to be transformed into, e.g. an HTML representation","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_push_list/2","title":"Extractly.Toc.Renderer.AstRenderer.render_push_list/2","type":"function"},{"doc":"","ref":"Extractly.Tools.html","title":"Extractly.Tools","type":"module"},{"doc":"Extract lines from either a file given by name a Stream or returns the list passed in as in a NOP","ref":"Extractly.Tools.html#lines_from_source/1","title":"Extractly.Tools.lines_from_source/1","type":"function"},{"doc":"A convenience function to repeat a string, it is a shortform for [ str ] |&gt; Stream . cycle |&gt; Enum . take ( n ) |&gt; Enum . join","ref":"Extractly.Tools.html#repeat_string/2","title":"Extractly.Tools.repeat_string/2","type":"function"},{"doc":"This wraps Extractly's API by putting all messages to be logged to the Extractly.Messages module. Its primarty use case is for Mix.Tasks.Xtra which will pass this module as a param into the EEx template. The general idea is Extractly.Messages . start_agent process_input_template # which will collect messages by means of this module&#39;s API Extractly.Messages . get_all |&gt; emit_messages ( options ) The wrapping works as follows def some_function ( some_params ) do case Extractly . some_function ( some_params ) do { :ok , result } -&gt; result { :error , message } -&gt; add_message_to_messages_and_return_html_comment_describing_the_error ( ) end end","ref":"Extractly.Xtra.html","title":"Extractly.Xtra","type":"module"},{"doc":"Just a delegator to Extractly.do_not_edit_warning As there can be no error condition no wrapping is needed iex(1)&gt; do_not_edit_warning() &quot;&lt;!--\\nDO NOT EDIT THIS FILE\\nIt has been generated from a template by Extractly ( https://github.com/RobertDober/extractly.git)\\nand any changes you make in this file will most likely be lost\\n--&gt;&quot;","ref":"Extractly.Xtra.html#do_not_edit_warning/1","title":"Extractly.Xtra.do_not_edit_warning/1","type":"function"},{"doc":"Wraps call to Extractly.functiondoc as described above iex(2)&gt; functiondoc ( [ &quot;Support.Module2.function/0&quot; , &quot;Support.Module1.hello/0&quot; ] ) &quot;A function \\n A nice one \\n \\n Functiondoc of Module1.hello \\n &quot;","ref":"Extractly.Xtra.html#functiondoc/2","title":"Extractly.Xtra.functiondoc/2","type":"function"},{"doc":"Wraps call to Extractly.moduledoc as described above iex(3)&gt; moduledoc ( &quot;Support.Module2&quot; ) &quot;&lt;!-- module Support.Module2 does not have a moduledoc --&gt;&quot;","ref":"Extractly.Xtra.html#moduledoc/2","title":"Extractly.Xtra.moduledoc/2","type":"function"},{"doc":"Wraps a call to Extractly.toc If a filename is provided the TOC is extracted from the filename and inserted into the document However, if :self is provided as an argument a placeholder is inserted into the document which allows the Mix task xtra to replace the placeholder with the TOC created from the very same document iex(4)&gt; toc ( :self ) &quot;&lt;!---- Extractly Self TOC \#{ inspect % Extractly.Toc.Options { } } ----&gt;&quot; iex(5)&gt; toc ( &quot;test/fixtures/toc-short.md&quot; , min_level : 2 ) &quot;- Level2 1.first \\n - Level2 1.second \\n - Level3 1.second(i)&quot; Errors are handled with comments and output to stderr, as usual iex(5)&gt; toc ( &quot;surelythisfiledoesnotexist.eajeza963q1hf&quot; ) &quot;&lt;!-- could not read from \\&quot; surelythisfiledoesnotexist.eajeza963q1hf \\&quot; --&gt;&quot;","ref":"Extractly.Xtra.html#toc/2","title":"Extractly.Xtra.toc/2","type":"function"},{"doc":"Mix task to Transform EEx templates in the context of the Extractly module. This tool serves two purposes. A simple CLI to basicly EEx.eval_file/2 Access to the Extractly module (available as binding xtra too) Access to the name of the rendered template with the template binding The Extractly module gives easy access to Elixir metainformation of the application using the extractly package, notably, module and function documentation. This is BTW the raison d'être of this package, simple creation of a README.md file with very simple access to the projects hex documentation. Thusly hexdoc and Github will always be synchronized. To see that in action just look at the README.md.eex file of this package and compare with what you are reading here. Example Template: Some text &lt; % = xtra . functiondoc ( &quot;M.shiny_function/2&quot; ) % &gt; &lt; % = xtra . moduledoc ( &quot;String&quot; ) % &gt; &lt; % = xtra . moduledoc ( &quot;MyModule&quot; , include : :all ) % &gt; &lt; % = xtra . toc &quot;SomeFile.md&quot; % &gt; More text A special case is the occurrence of &lt;%= xtra.toc :self, ... %&gt; which just inserts a placeholder which than is replaced by the TOC of the generated output in a second pass","ref":"Mix.Tasks.Xtra.html","title":"Mix.Tasks.Xtra","type":"task"},{"doc":"Usage: mix xtra [ options ] ... [ template ] Options: -- help | - h Prints short help information to stdout and exits . -- quiet | - q No output to stdout or stderr -- version | - v Prints the current version to stdout and exits . -- verbose | - V Prints additional output to stderr -- output filename The name of the file the rendered template is written to , defaults to the templates &#39; name , without the suffix ` . eex ` Argument: template , filename of the ` EEx ` template to use , defaults to ` &quot;README.md.eex&quot; `","ref":"Mix.Tasks.Xtra.Help.html","title":"Mix.Tasks.Xtra.Help","type":"task"}]